 

import java.util.Random;

 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2.0 10.03.2014
 */
public class Skispringer {
	// Attribute
	private String zName;
	private int zPunkte1, zPunkte2;

	// Der Ausgangspunkt einer Quelle von Zufallszahlen wird gesetzt
	private static Random hatRandom = new Random();

	// Konstruktor
	/**
	 * Der Skispringer wird mit zufaelligem Namen und 0 Punkten initialisiert.
	 */
	public Skispringer() {
		zName = this.zufallsgriff("BDFGHJKLMNPRSTVWZ")
				+ this.zufallsgriff("aeiou")
				+ this.zufallsgriff("dfghklmnprstxz") + this.zufallsendung();
		zPunkte1 = 0;
		zPunkte2 = 0;
	}

	// Dienste
	/**
	 * Der Name des Skispringers wird geliefert.
	 */
	public String name() {
		return zName;
	}

	/**
	 * Die Punktzahl des Skispringers aus dem angegebenen Durchgang wird
	 * geliefert.
	 */
	public int punktzahl(int pDurchgang) {
		if (pDurchgang == 1)
			return zPunkte1;
		else
			return zPunkte2;
	}

	/**
	 * Die Gesamtpunktzahl des Skispringers aus dem angegebenen Durchgang wird
	 * geliefert.
	 */
	public int gesamtpunktzahl() {
		return zPunkte1 + zPunkte2;
	}

	/**
	 * Die Punktzahl des Skispringers im angegebenen Durchgang wird im
	 * angegebenen Bereich zufaellig festgelegt.
	 */
	public void setzePunktzahl(int pDurchgang, int pMinimum, int pMaximum) {
		int lPunktzahl = this.ganzeZufallszahl(pMinimum, pMaximum);
		if (pDurchgang == 1)
			zPunkte1 = lPunktzahl;
		else
			zPunkte2 = lPunktzahl;
	}

	private String zufallsgriff(String moeglicheZeichen) {
		return ""
				+ moeglicheZeichen.charAt(this.ganzeZufallszahl(0,
						moeglicheZeichen.length() - 1));
	}

	private String zufallsendung() {
		switch (this.ganzeZufallszahl(1, 5)) {
		case 1:
			return "meier";
		case 2:
			return "mueller";
		case 3:
			return "schulze";
		case 4:
			return "mann";
		case 5:
			return "hausen";
		}
		return "";
	}

	private int ganzeZufallszahl(int pMinimum, int pMaximum) {
		return pMinimum + hatRandom.nextInt(pMaximum - pMinimum + 1);
	}
}
