  /**
 * <p>Qualitaets- und UnterstuetzungsAgentur  Landesinstitut fr Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2.1 28.04.2014
 */
public class Teilnehmerliste extends List<Teilnehmer> {

	/**
	 * Der Trenner wird zwischen die einzelnen Listenelemente eingefuegt
	 * 
	 * @param trenner
	 * @return
	 */
	public String toString(String trenner) {
		String result = "";
		this.toFirst();
		while (this.hasAccess()) {
			Teilnehmer tn = this.getContent();
			result += tn.toString();
			this.next();
			if (this.hasAccess()) {
				result += trenner;
			}
		}
		return result;
	}

	/**
	 * Ausgabe mit Standardtrenner
	 */
	public String toString() {
		return this.toString("/");
	}

	public Teilnehmerliste() {
		super();
	}

	/**
	 * 
	 * Der angegebene Teilnehmer wird einsortiert. Dabei wird - je nach
	 * Durchgang - die jeweilige Punktezahl als Sortierkriterium benutzt.
	 * 
	 * @param pSpringer
	 * @param pDurchgang
	 */
	public void einsortieren(Teilnehmer pSpringer, int pDurchgang) {
		this.toFirst();
		boolean einsortiert = false;
		while (!einsortiert && this.hasAccess()) {
			Teilnehmer dieser = this.getContent();
			if (pSpringer.gibPunkte(pDurchgang) > dieser.gibPunkte(pDurchgang)) {
				this.insert(pSpringer);
				einsortiert = true;
			} else {
				this.next();
			}
		}
		if (!einsortiert) {
			this.append(pSpringer);
		}
	}

	/**
	 * @param anzahl
	 * @return eine neue Liste, die die ersten "anzahl" Teilnehmer enthaelt.
	 */
	public Teilnehmerliste vorderePlaetze(int anzahl) {
		Teilnehmerliste result = new Teilnehmerliste();
		this.toFirst();
		for (int i = 0; i < anzahl && this.hasAccess(); i++) {
			result.append(this.getContent());
			this.next();
		}
		return result;
	}

	/**
	 * 
	 * @return die Liste, in der die Teilnehmer in umgekehrter Reihenfolge
	 *         enthalten sind.
	 */
	public Teilnehmerliste reverse() {
		Teilnehmerliste result = new Teilnehmerliste();
		this.toFirst();
		while (this.hasAccess()) {
			result.toFirst();
			result.insert(this.getContent());
			this.next();
		}
		return result;
	}
}
